# coffeelint: disable=max_line_length
configloader = require 'omg-configloader'
sockets = require 'omg-zmqsockets'
debug = require("debug")("omg-PorthandlerConnection")
async = require 'async'

porthandlerPort = ->
  zmqconfig = configloader.zmq
  porthandlerConfig = zmqconfig.porthandler
  transport = porthandlerConfig.transport or zmqconfig.standardTransport
  address = porthandlerConfig.address or zmqconfig.standardAddress
  port = porthandlerConfig.rep
  return "#{transport}://#{address}:#{port}"

# receive response from porthandler
PortHandlerConnection = (name) ->
  debug "creating connection to porthandler for #{name} (to #{porthandlerPort()})"
  requestSocket = new sockets.SecureConnectedSocket name, "req", porthandlerPort()
  portRequestQueue = async.queue (task, cb) ->
    {name, socketType} = task
    requestSocket.once "message", (port) ->
      debug "got port for #{name}#{socketType} #{port}"
      cb port
    requestSocket.send [name, socketType]
  , 1

  requestSocket.getPortFor = (name, socketType, cb) ->
    debug "#{name} wants port for ", name, socketType
    portRequestQueue.push {name: name, socketType: socketType}, cb
  return requestSocket

module.exports = PortHandlerConnection
