#
# * prod_coredumpcheck
# *
# * Copyright (c) 2015 Ferrari electronic AG
#
# "use strict"
_ = require("lodash")
fs = require 'fs'
exec = require("child_process").exec
logger = require("omg-logger")
path = require 'path'



Producer = require "../../ProducerClass"

isWatching = false
watchDir = "/usr/fb/bin/sipisdn/"

class Coredumpcheck extends Producer
  constructor: ->
    super "coredumpcheck", 10 * 1000

    dumpFiles = []

    allDumpFiles = []
    getDumpFiles = (callback) =>
      fs.readdir watchDir, (error, files) =>
        logger.error error if error
        allDumpFiles = ({name: fileName, time: (new Date()).toString()} for fileName in files when fileName.lastIndexOf("core", 0) is 0)
        callback() if callback


    send = =>
      @sendData allDumpFiles, true

    throttledGetAndSend = _.throttle(->
      getDumpFiles send
    , 1000)

    @start = =>
      #initially get dumpFiles and send them
      getDumpFiles send

      #reset watcher and start watching for changes
      watcher.close() if watcher
      watcher = false
      watcher = fs.watch watchDir, (event, filename) =>
        logger.silly "#{filename} changed: #{event}"

        # if a core dump file changed, get dump files and send them
        if filename.lastIndexOf("core", 0) is 0
          throttledGetAndSend()

    @stop = =>
      isWatching = false
      watcher.close() if watcher
      watcher = false

    @delete = (file) =>
      if file is "all"
        logger.silly "deleting all core dumps"
        fs.readdir watchDir, (error, files) =>
          logger.error error if error
          allDumpFiles = (fileName for fileName in files when fileName.lastIndexOf("core", 0) is 0)
          _.each allDumpFiles, (fileName) =>
            fs.unlink "#{watchDir}#{fileName}"
            @start()
      else
        file = path.basename file # remove path sections from file for security reasons
        # delete if file exists
        logger.debug "deleting #{file}"
        fs.unlink "#{watchDir}#{file}", (err)=>
          @start() unless err


    @getStatus = (callback) =>
      if callback
        callback null, allDumpFiles

  subscribe: =>
    unless isWatching
      isWatching = true
      @start()
    super


module.exports = new Coredumpcheck()
