# coffeelint: disable=max_line_length
_ = require("lodash")
Producer = require '../../ProducerClass'
os = require("os")
debug = require("debug")("omg-cpuload")

isRunning = false

class Cpuload extends Producer

  constructor: () ->
    super "cpuload", 15000

    run = =>
      timeout = 1
      old = _.map os.cpus(), (cpu) ->
        cpu.times

      getNew = =>
        result = []
        current = _.map os.cpus(), (cpu) ->
          cpu.times

        _.each current, (item, cpuKey) ->
          result[cpuKey] = {}
          oldVal = old[cpuKey]
          _.each _.keys(item), (timeKey) ->
            diff = (parseFloat((item[timeKey]) - parseFloat(oldVal[timeKey])) / parseFloat((timeout * 100)))
            name = timeKey
            if timeKey is "idle"
              name = "CPU"
              diff = 100 - diff

            result[cpuKey][name] = diff.toFixed(0)

        old = current

        debug "sending cpu"
        @sendData result

      setTimeout getNew, 1000

    runInterval = false
    @start = ->
      clearInterval runInterval if runInterval
      # set interval to get new cpu every second
      runInterval = setInterval(run, 1000)

    @stop = ->
      debug "stopping"
      isRunning = false
      clearInterval runInterval if runInterval

  subscribe: =>
    debug "someone subscribed, starting"
    unless isRunning
      isRunning = true
      @start()
    super

  #run once on start

cpu = new Cpuload()
cpu.subscribe()
module.exports = cpu
