###
* omg-dnsconfig
*
* Copyright (c) 2015 Ferrari electronic AG
###

'use strict'
exec = require "child_process"
	.exec

debug = require("debug")("omg-dnsconfig")

Producer = require "../../ProducerClass"

class DnsConfig extends Producer
	isRunning = false
	constructor: ->
		super "dnsconfig", 15 * 1000

		getNewData = false
		run = =>
			probe = exec __dirname + "/lua/probeDNS.lua", (error, stdout, stderr) =>
				@sendError error if error
				debug error if error
				debug stderr if stderr
				try
					stdout = JSON.parse(stdout)
					@sendData stdout
				catch e
					debug "could not parse #{stdout}"


		run()

		@start = =>
			debug "starting"
			#run directly
			run()
			clearInterval getNewData if getNewData
			getNewData = setInterval run, 15 * 1000


		@stop = =>
			isRunning = false
			clearInterval getNewData if getNewData
			@sendStatus "stopped"

	subscribe: =>
		unless isRunning
			isRunning = true
			@start()
		super

module.exports = new DnsConfig()



omg_dnsconfig = (callback) ->
	probe = exec __dirname + "/lua/probeDNS.lua", (error, stdout, stderr) ->
		callback error if error
		console.log stderr if stderr
		try
			stdout = JSON.parse(stdout)
			callback null, stdout
		catch e
			callback "could not parse #{stdout}"
			debug "could not parse #{stdout}"


exports.start = omg_dnsconfig