###
 * omg-isdnconnectionsstate
 *
 * Copyright (c) 2015 Ferrari electronic AG
 *
 ###

'use strict';
child_process = require 'child_process'
_ = require "lodash"
fs = require 'fs'
debug = require("debug")("omg-isdnconnectionsstate")
parser = require("table-parser").parse
parseArgs = require "minimist"

Producer = require "../../ProducerClass"

class IsdnConnectionState extends Producer
  isRunning = false
  constructor: ->
    super "isdnconnectionsstate", 15 * 1000

    getLayerState = (ilid) ->
      command = "checkl1 /dev/ilid #{ilid}/D | grep \"Layer1 activated\" | wc -l"

    getL2State = (ilid) ->


    refreshIsdnStates = (cb) ->
      # getting isdn processes

      # temporary using file with "processes". Uncomment next lines for production
      command = "ps -C isdn.prc l"
      child_process.exec command, (error, stdout, stderr) ->

      ## remove this when using real process list
      # fs.readFile "#{__dirname}/../tempisdnprocessList", (err, stdout) ->
        # return if error
        # stdout = stdout.toString() if stdout
      ## /

        # we only need the isdn processes arguments for later use
        allIsdnProcessCommands = (parseArgs((process_loop.COMMAND)) for process_loop in parser(stdout))
        # debug "arguments of running isdn process: #{JSON.stringify(allIsdnProcessCommands, null, 2)}"

        _.each allIsdnProcessCommands, (com) ->
          ilid = "#{com.slot}.#{com['slot-index']}"
          getLayerState(ilid)
    refreshIsdnStates()

    getNewData = false
    run = =>
      child_process.exec "LC_ALL=C getstates", (error, stdout) =>
        states = {}
        splitStdout = stdout.split "\n"
        lines = _.without splitStdout, ""
        for key, line of lines
          item = {}
          pairs = line.split ", "
          for pair in pairs
            sep = pair.split ":"
            key = sep[0]
            val = sep[1]
            item[key] = val
          states[item.ILID] = item

        debug "sending states"#, states
        @sendData states
    run()

    @start = =>
      @debug "starting"
      #run directly
      run()
      clearInterval getNewData if getNewData
      getNewData = setInterval run, 5 * 1000

    @stop = =>
      clearInterval getNewData if getNewData
      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new IsdnConnectionState()