# coffeelint: disable=max_line_length

_ = require "lodash"
fs = require 'fs'
exec = require "child_process"
  .exec

ko = require "knockout"

debug = require("debug")("omg-messagingservers")

async = require 'async'

Producer = require "../../ProducerClass"

config2object = (string) ->
  string = string.replace /\n/g, ""
  asArray = string.split " --"
  asArray = asArray[1..]
  asArray = (toBeObject.split("=") for toBeObject in asArray)
  oneServer = _.object(asArray)

isJCFile = (filename) ->
  filename.lastIndexOf("JC-", 0) is 0
isCurrentJCFile = (filename) ->
  filename.lastIndexOf("JC-", 0) is 0 and filename.lastIndexOf("JC-D", 0) isnt 0


class MessagingServers extends Producer
  isRunning = false
  watcher = false
  watchDir = "/tmp/"

  constructor: ->
    super "messagingservers", 10 * 1000

    allMessagingServers = {}
    filesChanged = ko.observable().extend({notify: "always"})

    sendNewData = =>
      allMessagingServers = _.sortBy allMessagingServers, "ilid_index"
      @sendData allMessagingServers, true
      @sendData allMessagingServers

    addMessagingServer = (filename, asyncCallback) ->
      # filenameIndex = parseInt(filename.match(/(\d+)$/)[0], 10)
      filenameIndex = filename
      fs.readFile "#{watchDir}#{filename}", (err, data) ->
        if data
          data = data.toString()
          data = config2object data
          data.partner = data.partner.split("|")[1] if data.partner
          data.ilid_index = JSON.parse(data.ilid_index) if data.ilid_index
          data.date = JSON.parse(data.date) if data.date
          allMessagingServers[filenameIndex] = data if data.partner and data.partner isnt ("127.0.0.1" or "none") #filter connections from local host (can happen when running testfax)
        asyncCallback()

    run = =>
      #reset
      allMessagingServers = {}

      fs.readdir watchDir, (err, files) ->
        jcFiles = (filename for filename in files when isJCFile(filename))
        #check if there are files that contain currently connected messagingservers
        currentJCFiles = _.filter jcFiles, isCurrentJCFile
        #parse each JC-File then send data
        async.map currentJCFiles, addMessagingServer, sendNewData

    run()

    throttledRunAfterFileChange = ko.computed ->
      if filesChanged() is true
        run()
    .extend({throttle: 1000})

    @start = =>
      @debug "starting"
      #run directly
      run()
      watcher.close() if watcher
      watcher = false

      watcher = fs.watch watchDir, (event, filename) =>
        if isJCFile(filename)
          debug "#{filename} changed"
          filesChanged(true)

    @stop = =>
      isRunning = false
      watcher.close() if watcher
      watcher = false
      @sendStatus "stopped"

      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new MessagingServers()
