#
# * prod_statics
# *
# * Copyright (c) 2015 Ferrari electronic AG
#

"use strict"
exec = require("child_process").exec
logger = require("omg-logger")
os = require("os")
_ = require("lodash")

debug = require("debug")("omg-statics")

Producer = require "../../ProducerClass"

class Statics extends Producer
  isRunning = false
  constructor: ->
    super "statics", 10 * 1000

    getNewData = false

    run = =>
      execOptions =
        cwd: __dirname
        maxBuffer: 10000 * 1024

      handleExecResult = (error, stdout) =>
        logger.error error.message if error
        return unless stdout
        try
          js = JSON.parse(stdout)
          js.hostname = os.hostname()
          @sendData js
        catch e
          debug "STATICJSON(lua):" + e.message
          logger.error e.message
          @sendError e

      exec __dirname + "/lua/staticJson.lua", execOptions, handleExecResult

    @start = =>
      @debug "starting"
      #run directly
      run()
      clearInterval getNewData if getNewData
      getNewData = setInterval run, 30 * 1000

    @start()

    @stop = =>
      clearInterval getNewData if getNewData
      isRunning = false

  subscribe: =>
    unless isRunning
      isRunning = true
      @start()
    super

module.exports = new Statics()
