#
# * prod_testfax
# *
# * Copyright (c) 2015 Ferrari electronic AG
#
"use strict"
spawn = require("child_process").spawn
_ = require("lodash")
path = require("path")
logger = require("omg-logger")

debug = require("debug")("omg-testfax")

Producer = require "../../ProducerClass"

class Testfax extends Producer
	isRunning = false
	testfaxProcess = undefined
	constructor: ->
		super "testfax"

		@start = (settings) =>
			@debug "starting"
			testfaxProcess.kill() if testfaxProcess

			@sendStatus "started"
			@sendData "", true #resetting output

			command = path.normalize(__dirname + "/lua/testFax.lua")
			args = []
			args.push settings.host
			args.push settings.port
			args.push settings.callingPartyNumber
			args.push settings.calledPartyNumber
			testfaxProcess = spawn(command, args)

			@sendStatus "running"

			testfaxProcess.stdout.on "data", (data) =>

				# logger.debug(data);
				data = data.toString("utf-8")
				data = data.split("\n")
				data = _.without(data, "")
				data.pop() # removing double data (array)

				@sendData data

			testfaxProcess.on "close", (returnCode) =>
				@sendStatus "stopped"


module.exports = new Testfax()